diff -pruN 2.10.15-1/azure-devops/build-windows.yml 2.10.16-1/azure-devops/build-windows.yml
--- 2.10.15-1/azure-devops/build-windows.yml	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/azure-devops/build-windows.yml	2020-04-25 00:44:16.000000000 +0000
@@ -13,11 +13,6 @@ jobs:
   steps:
     - script: git submodule update --init vcpkg
       displayName: Checkout vcpkg submodule
-    - task: CacheBeta@0
-      displayName: Cache vcpkg
-      inputs:
-        key: $(vcpkgResponseFile) | $(Build.SourcesDirectory)/.git/modules/vcpkg/HEAD | ${{ parameters.targetPlatform }} | ${{ parameters.image }}
-        path: '$(vcpkgLocation)'
     - task: run-vcpkg@0
       displayName: 'Run vcpkg'
       inputs:
diff -pruN 2.10.15-1/azure-pipelines.yml 2.10.16-1/azure-pipelines.yml
--- 2.10.15-1/azure-pipelines.yml	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/azure-pipelines.yml	2020-04-25 00:44:16.000000000 +0000
@@ -21,16 +21,6 @@ jobs:
       name: 'Windows_VS2017_x64'
       targetPlatform: x64
       image: 'vs2017-win2016'
-  - template: azure-devops/build-windows.yml
-    parameters:
-      name: 'Windows_VS2015_x86'
-      targetPlatform: x86
-      image: 'vs2015-win2012r2'
-  - template: azure-devops/build-windows.yml
-    parameters:
-      name: 'Windows_VS2015_x64'
-      targetPlatform: x64
-      image: 'vs2015-win2012r2'
   - job: Windows_VS2019_UWP
     pool:
       vmImage: 'windows-latest'
@@ -78,85 +68,89 @@ jobs:
         export NCPU=2
         ../configure.sh --ndk /usr/local/lib/android/sdk/ndk-bundle
       displayName: 'Build for Android'
-  # - job: MacOS_Homebrew
-  #   pool:
-  #     vmImage: 'macOS-latest'
-  #   steps:
-  #   - script: brew install boost openssl ninja
-  #     displayName: Brew install dependencies
-  #   - script: |
-  #       mkdir build.debug
-  #       mkdir build.release
-  #       mkdir build.release.static
-  #     displayName: Make Build Directories
-  #   - task: CMake@1
-  #     inputs:
-  #       workingDirectory: 'build.debug'
-  #       cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Debug ..'
-  #   - task: CMake@1
-  #     inputs:
-  #       workingDirectory: 'build.release'
-  #       cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Release ..'
-  #   - task: CMake@1
-  #     inputs:
-  #       workingDirectory: 'build.release.static'
-  #       cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF ..'
-  #   - script: |
-  #       cd build.debug
-  #       ninja
-  #     displayName: 'Run ninja, debug'
-  #   - script: |
-  #       cd build.debug/Release/Binaries
-  #       ./test_runner *test.dylib
-  #     displayName: 'Run tests, debug'
-  #   - script: |
-  #       cd build.release
-  #       ninja
-  #     displayName: 'Run ninja, release'
-  #   - script: |
-  #       cd build.release/Release/Binaries
-  #       ./test_runner *test.dylib
-  #     displayName: 'Run tests, release'
-  #   - script: |
-  #       cd build.release.static
-  #       ninja
-  #     displayName: 'Run ninja, release static'
-  # - job: MacOS_Vcpkg
-  #   pool:
-  #     vmImage: 'macOS-latest'
-  #   steps:
-  #   - script: |
-  #       ./vcpkg/bootstrap-vcpkg.sh
-  #       ./vcpkg/vcpkg install zlib openssl boost-system boost-date-time boost-regex websocketpp boost-thread boost-filesystem boost-random boost-chrono boost-interprocess brotli --vcpkg-root ./vcpkg
-  #     displayName: Vcpkg install dependencies
-  #   - script: |
-  #       mkdir build.debug
-  #       mkdir build.release
-  #     displayName: Make Build Directories
-  #   - task: CMake@1
-  #     inputs:
-  #       workingDirectory: 'build.debug'
-  #       cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Debug -DCMAKE_TOOLCHAIN_FILE=../vcpkg/scripts/buildsystems/vcpkg.cmake ..'
-  #   - task: CMake@1
-  #     inputs:
-  #       workingDirectory: 'build.release'
-  #       cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Release -DCMAKE_TOOLCHAIN_FILE=../vcpkg/scripts/buildsystems/vcpkg.cmake ..'
-  #   - script: |
-  #       cd build.debug
-  #       ninja
-  #     displayName: 'Run ninja debug'
-  #   - script: |
-  #       cd build.debug/Release/Binaries
-  #       ./test_runner *test.dylib
-  #     displayName: 'Run Tests debug'
-  #   - script: |
-  #       cd build.release
-  #       ninja
-  #     displayName: 'Run ninja, release'
-  #   - script: |
-  #       cd build.release/Release/Binaries
-  #       ./test_runner *test.dylib
-  #     displayName: 'Run tests, release'
+  - job: MacOS_Homebrew
+    pool:
+      vmImage: 'macOS-latest'
+    steps:
+    - script: brew install boost openssl ninja
+      displayName: Brew install dependencies
+    - script: git submodule update --init Release/libs/websocketpp
+      displayName: Checkout websocketpp submodule
+    - script: |
+        mkdir build.debug
+        mkdir build.release
+        mkdir build.release.static
+      displayName: Make Build Directories
+    - task: CMake@1
+      inputs:
+        workingDirectory: 'build.debug'
+        cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Debug ..'
+    - task: CMake@1
+      inputs:
+        workingDirectory: 'build.release'
+        cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Release ..'
+    - task: CMake@1
+      inputs:
+        workingDirectory: 'build.release.static'
+        cmakeArgs: '-G Ninja -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF ..'
+    - script: |
+        cd build.debug
+        ninja
+      displayName: 'Run ninja, debug'
+    - script: |
+        cd build.debug/Release/Binaries
+        ./test_runner *test.dylib
+      displayName: 'Run tests, debug'
+    - script: |
+        cd build.release
+        ninja
+      displayName: 'Run ninja, release'
+    - script: |
+        cd build.release/Release/Binaries
+        ./test_runner *test.dylib
+      displayName: 'Run tests, release'
+    - script: |
+        cd build.release.static
+        ninja
+      displayName: 'Run ninja, release static'
+  - job: MacOS_Vcpkg
+    pool:
+      vmImage: 'macOS-latest'
+    steps:
+    - script: git submodule update --init vcpkg
+      displayName: Checkout vcpkg submodule
+    - script: |
+        ./vcpkg/bootstrap-vcpkg.sh
+        ./vcpkg/vcpkg install zlib openssl boost-system boost-date-time boost-regex websocketpp boost-thread boost-filesystem boost-random boost-chrono boost-interprocess brotli --vcpkg-root ./vcpkg
+      displayName: Vcpkg install dependencies
+    - script: |
+        mkdir build.debug
+        mkdir build.release
+      displayName: Make Build Directories
+    - task: CMake@1
+      inputs:
+        workingDirectory: 'build.debug'
+        cmakeArgs: '-G Ninja -DCMAKE_MAKE_PROGRAM=$(Build.SourcesDirectory)/vcpkg/downloads/tools/ninja-1.10.0-osx/ninja -DCMAKE_BUILD_TYPE=Debug -DCMAKE_TOOLCHAIN_FILE=../vcpkg/scripts/buildsystems/vcpkg.cmake ..'
+    - task: CMake@1
+      inputs:
+        workingDirectory: 'build.release'
+        cmakeArgs: '-G Ninja -DCMAKE_MAKE_PROGRAM=$(Build.SourcesDirectory)/vcpkg/downloads/tools/ninja-1.10.0-osx/ninja -DCMAKE_BUILD_TYPE=Release -DCMAKE_TOOLCHAIN_FILE=../vcpkg/scripts/buildsystems/vcpkg.cmake ..'
+    - script: |
+        cd build.debug
+        $(Build.SourcesDirectory)/vcpkg/downloads/tools/ninja-1.10.0-osx/ninja
+      displayName: 'Run ninja debug'
+    - script: |
+        cd build.debug/Release/Binaries
+        ./test_runner *test.dylib
+      displayName: 'Run Tests debug'
+    - script: |
+        cd build.release
+        $(Build.SourcesDirectory)/vcpkg/downloads/tools/ninja-1.10.0-osx/ninja
+      displayName: 'Run ninja, release'
+    - script: |
+        cd build.release/Release/Binaries
+        ./test_runner *test.dylib
+      displayName: 'Run tests, release'
   # - job: MacOS_iOS
   #   pool:
   #     vmImage: 'macOS-latest'
diff -pruN 2.10.15-1/Build_iOS/CMakeLists.txt 2.10.16-1/Build_iOS/CMakeLists.txt
--- 2.10.15-1/Build_iOS/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Build_iOS/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -1,5 +1,5 @@
 project(casablanca-ios NONE)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 
 enable_testing()
 
diff -pruN 2.10.15-1/changelog.md 2.10.16-1/changelog.md
--- 2.10.15-1/changelog.md	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/changelog.md	2020-04-25 00:44:16.000000000 +0000
@@ -1,3 +1,16 @@
+cpprestsdk (2.10.16)
+* PR#1383 CMake fixes + CMake search for OpenSSL (macOS)
+* PR#1392 Update submodule websocketpp to 0.8.2
+* PR#1393 Do not report errors (such as EBADF and EINVAL) from setsockopt here, since this is a performance optimization only, and hard errors will be picked up by the following operation
+* PR#1379 Fix compilation with GCC 4.8/4.9, which was broken by commit 53fab3a.
+* PR#1328 Add support for HTTP redirection in ASIO and WinHTTP-based http_clients
+* PR#1332 Fix more http test build fails in certain configurations
+* PR#1370 Remove redundant std::move noted by gcc 9.2 (-Wredundant-move)
+* PR#1372 Static analyzer (PVS Studio) fixes
+* PR#1350 Expose json::value::parse for UTF8 string on Windows
+* PR#1344 libcpprestsdk: fix building as a static library
+-- cpprestsdk team <askcasablanca@microsoft.com>  FRI, 24 Apr 2020 16:56:00 -0700
+
 cpprestsdk (2.10.15)
 * Extremely special thanks to @garethsb-sony for a large number of contributions in this release
 * PR#1209 Workarounds for two GCC 4.7.2 bugs with lambda functions
diff -pruN 2.10.15-1/CMakeLists.txt 2.10.16-1/CMakeLists.txt
--- 2.10.15-1/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 project(cpprestsdk-root NONE)
 enable_testing()
 add_subdirectory(Release)
diff -pruN 2.10.15-1/debian/changelog 2.10.16-1/debian/changelog
--- 2.10.15-1/debian/changelog	2020-02-27 14:15:54.000000000 +0000
+++ 2.10.16-1/debian/changelog	2020-05-03 09:46:28.000000000 +0000
@@ -1,3 +1,9 @@
+cpprest (2.10.16-1) unstable; urgency=medium
+
+  * New upstream version 2.10.16
+
+ -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 May 2020 11:46:28 +0200
+
 cpprest (2.10.15-1) unstable; urgency=medium
 
   * New upstream version 2.10.15
diff -pruN 2.10.15-1/README.md 2.10.16-1/README.md
--- 2.10.15-1/README.md	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/README.md	2020-04-25 00:44:16.000000000 +0000
@@ -39,7 +39,7 @@ Once you have the library, look at our [
 
 To use from CMake:
 ```cmake
-cmake_minimum_required(VERSION 3.7)
+cmake_minimum_required(VERSION 3.9)
 project(main)
 
 find_package(cpprestsdk REQUIRED)
diff -pruN 2.10.15-1/Release/cmake/cpprest_find_openssl.cmake 2.10.16-1/Release/cmake/cpprest_find_openssl.cmake
--- 2.10.15-1/Release/cmake/cpprest_find_openssl.cmake	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/cmake/cpprest_find_openssl.cmake	2020-04-25 00:44:16.000000000 +0000
@@ -34,14 +34,24 @@ function(cpprest_find_openssl)
     if(APPLE)
       if(NOT DEFINED OPENSSL_ROOT_DIR)
         # Prefer a homebrew version of OpenSSL over the one in /usr/lib
-        file(GLOB OPENSSL_ROOT_DIR /usr/local/Cellar/openssl/*)
+        file(GLOB OPENSSL_ROOT_DIR /usr/local/Cellar/openssl*/*)
         # Prefer the latest (make the latest one first)
         list(REVERSE OPENSSL_ROOT_DIR)
+        list(GET OPENSSL_ROOT_DIR 0 OPENSSL_ROOT_DIR)
       endif()
       # This should prevent linking against the system provided 0.9.8y
+      message(STATUS "OPENSSL_ROOT_DIR = ${OPENSSL_ROOT_DIR}")
       set(_OPENSSL_VERSION "")
     endif()
-    find_package(OpenSSL 1.0.0 REQUIRED)
+    if(UNIX)
+      find_package(PkgConfig)
+      pkg_search_module(OPENSSL openssl)
+    endif()
+    if(OPENSSL_FOUND)
+      target_link_libraries(cpprest PRIVATE ${OPENSSL_LDFLAGS})
+    else()
+      find_package(OpenSSL 1.0.0 REQUIRED)
+    endif()
 
     INCLUDE(CheckCXXSourceCompiles)
     set(CMAKE_REQUIRED_INCLUDES "${OPENSSL_INCLUDE_DIR}")
@@ -67,4 +77,4 @@ function(cpprest_find_openssl)
     # libressl doesn't ship with the cleanup method being used in ws_client_wspp
     target_compile_definitions(cpprestsdk_openssl_internal INTERFACE -DCPPREST_NO_SSL_LEAK_SUPPRESS)
   endif()
-endfunction()
\ No newline at end of file
+endfunction()
diff -pruN 2.10.15-1/Release/cmake/cpprestsdk-config.in.cmake 2.10.16-1/Release/cmake/cpprestsdk-config.in.cmake
--- 2.10.15-1/Release/cmake/cpprestsdk-config.in.cmake	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/cmake/cpprestsdk-config.in.cmake	2020-04-25 00:44:16.000000000 +0000
@@ -15,7 +15,7 @@ if(@CPPREST_USES_WINHTTPPAL@)
   find_dependency(WINHTTPPAL)
 endif()
 
-if(@CPPREST_USES_BOOST@ AND OFF)
+if(@CPPREST_USES_BOOST@)
   if(UNIX)
     find_dependency(Boost COMPONENTS random system thread filesystem chrono atomic date_time regex)
   else()
diff -pruN 2.10.15-1/Release/cmake/cpprestsdk-config-version.in.cmake 2.10.16-1/Release/cmake/cpprestsdk-config-version.in.cmake
--- 2.10.15-1/Release/cmake/cpprestsdk-config-version.in.cmake	1970-01-01 00:00:00.000000000 +0000
+++ 2.10.16-1/Release/cmake/cpprestsdk-config-version.in.cmake	2020-04-25 00:44:16.000000000 +0000
@@ -0,0 +1,10 @@
+set(PACKAGE_VERSION @CPPREST_VERSION_MAJOR@.@CPPREST_VERSION_MINOR@.@CPPREST_VERSION_REVISION@)
+
+if(PACKAGE_VERSION VERSION_LESS PACKAGE_FIND_VERSION)
+    set(PACKAGE_VERSION_COMPATIBLE FALSE)
+else(PACKAGE_VERSION VERSION_LESS PACKAGE_FIND_VERSION)
+    set(PACKAGE_VERSION_COMPATIBLE TRUE)
+    if(PACKAGE_FIND_VERSION STREQUAL PACKAGE_VERSION)
+        set(PACKAGE_VERSION_EXACT TRUE)
+    endif(PACKAGE_FIND_VERSION STREQUAL PACKAGE_VERSION)
+endif(PACKAGE_VERSION VERSION_LESS PACKAGE_FIND_VERSION)
diff -pruN 2.10.15-1/Release/CMakeLists.txt 2.10.16-1/Release/CMakeLists.txt
--- 2.10.15-1/Release/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -1,5 +1,5 @@
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 if(POLICY CMP0042)
   cmake_policy(SET CMP0042 NEW) # use MACOSX_RPATH
 endif()
@@ -11,7 +11,7 @@ endif()
 
 set(CPPREST_VERSION_MAJOR 2)
 set(CPPREST_VERSION_MINOR 10)
-set(CPPREST_VERSION_REVISION 15)
+set(CPPREST_VERSION_REVISION 16)
 
 enable_testing()
 
diff -pruN 2.10.15-1/Release/include/cpprest/http_client.h 2.10.16-1/Release/include/cpprest/http_client.h
--- 2.10.15-1/Release/include/cpprest/http_client.h	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/include/cpprest/http_client.h	2020-04-25 00:44:16.000000000 +0000
@@ -107,6 +107,8 @@ public:
 #if (defined(_WIN32) && !defined(__cplusplus_winrt)) || defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
         , m_buffer_request(false)
 #endif
+        , m_max_redirects(10)
+        , m_https_to_http_redirects(false)
     {
     }
 
@@ -280,6 +282,38 @@ public:
 #endif
 
     /// <summary>
+    /// Get the maximum number of redirects to follow automatically.
+    /// A value of 0 indicates that no automatic redirection is performed.
+    /// </summary>
+    /// <returns>The maximum number of redirects to follow automatically.</returns>
+    /// <remarks>This is a hint -- an implementation may enforce a lower value.</remarks>
+    size_t max_redirects() const { return m_max_redirects; }
+
+    /// <summary>
+    /// Set the maximum number of redirects to follow automatically.
+    /// A value of 0 indicates that no automatic redirection is performed.
+    /// </summary>
+    /// <param name="max_redirects">The maximum number of redirects to follow automatically.</param>
+    /// <remarks>This is a hint -- an implementation may enforce a lower value.</remarks>
+    void set_max_redirects(size_t max_redirects) { m_max_redirects = max_redirects; }
+
+    /// <summary>
+    /// Checks if HTTPS to HTTP redirects are automatically followed.
+    /// </summary>
+    /// <returns>True if HTTPS to HTTP redirects are automatically followed, false otherwise.</returns>
+    bool https_to_http_redirects() const { return m_https_to_http_redirects; }
+
+    /// <summary>
+    /// Sets if HTTPS to HTTP redirects are automatically followed.
+    /// </summary>
+    /// <param name="https_to_http_redirects">True if HTTPS to HTTP redirects are to be automatically
+    /// followed, false otherwise.</param>
+    void set_https_to_http_redirects(bool https_to_http_redirects)
+    {
+        m_https_to_http_redirects = https_to_http_redirects;
+    }
+
+    /// <summary>
     /// Sets a callback to enable custom setting of platform specific options.
     /// </summary>
     /// <remarks>
@@ -392,6 +426,9 @@ private:
 #if (defined(_WIN32) && !defined(__cplusplus_winrt)) || defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
     bool m_buffer_request;
 #endif
+
+    size_t m_max_redirects;
+    bool m_https_to_http_redirects;
 };
 
 class http_pipeline;
diff -pruN 2.10.15-1/Release/include/cpprest/json.h 2.10.16-1/Release/include/cpprest/json.h
--- 2.10.15-1/Release/include/cpprest/json.h	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/include/cpprest/json.h	2020-04-25 00:44:16.000000000 +0000
@@ -390,17 +390,37 @@ public:
     /// <summary>
     /// Parses a string and construct a JSON value.
     /// </summary>
-    /// <param name="value">The C++ value to create a JSON value from, a C++ STL double-byte string</param>
+    /// <param name="value">The C++ value to create a JSON value from, a C++ STL string of the
+    /// platform-native character width</param>
     _ASYNCRTIMP static value __cdecl parse(const utility::string_t& value);
 
     /// <summary>
     /// Attempts to parse a string and construct a JSON value.
     /// </summary>
-    /// <param name="value">The C++ value to create a JSON value from, a C++ STL double-byte string</param>
+    /// <param name="value">The C++ value to create a JSON value from, a C++ STL string of the
+    /// platform-native character width</param>
     /// <param name="errorCode">If parsing fails, the error code is greater than 0</param>
     /// <returns>The parsed object. Returns web::json::value::null if failed</returns>
     _ASYNCRTIMP static value __cdecl parse(const utility::string_t& value, std::error_code& errorCode);
 
+#ifdef _WIN32
+    /// <summary>
+    /// Parses a string and construct a JSON value.
+    /// </summary>
+    /// <param name="value">The C++ value to create a JSON value from, a C++ STL string in
+    /// UTF8 format</param>
+    _ASYNCRTIMP static value __cdecl parse(const std::string& value);
+
+    /// <summary>
+    /// Attempts to parse a string and construct a JSON value.
+    /// </summary>
+    /// <param name="value">The C++ value to create a JSON value from, a C++ STL string in
+    /// UTF8 format</param>
+    /// <param name="errorCode">If parsing fails, the error code is greater than 0</param>
+    /// <returns>The parsed object. Returns web::json::value::null if failed</returns>
+    _ASYNCRTIMP static value __cdecl parse(const std::string& value, std::error_code& errorCode);
+#endif
+
     /// <summary>
     /// Serializes the current JSON value to a C++ string.
     /// </summary>
diff -pruN 2.10.15-1/Release/include/cpprest/producerconsumerstream.h 2.10.16-1/Release/include/cpprest/producerconsumerstream.h
--- 2.10.15-1/Release/include/cpprest/producerconsumerstream.h	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/include/cpprest/producerconsumerstream.h	2020-04-25 00:44:16.000000000 +0000
@@ -47,6 +47,7 @@ public:
     /// </summary>
     basic_producer_consumer_buffer(size_t alloc_size)
         : streambuf_state_manager<_CharType>(std::ios_base::out | std::ios_base::in)
+        , m_mode(std::ios_base::in)
         , m_alloc_size(alloc_size)
         , m_allocBlock(nullptr)
         , m_total(0)
diff -pruN 2.10.15-1/Release/include/cpprest/version.h 2.10.16-1/Release/include/cpprest/version.h
--- 2.10.15-1/Release/include/cpprest/version.h	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/include/cpprest/version.h	2020-04-25 00:44:16.000000000 +0000
@@ -5,6 +5,6 @@
  */
 #define CPPREST_VERSION_MINOR 10
 #define CPPREST_VERSION_MAJOR 2
-#define CPPREST_VERSION_REVISION 15
+#define CPPREST_VERSION_REVISION 16
 
 #define CPPREST_VERSION (CPPREST_VERSION_MAJOR * 100000 + CPPREST_VERSION_MINOR * 100 + CPPREST_VERSION_REVISION)
diff -pruN 2.10.15-1/Release/src/CMakeLists.txt 2.10.16-1/Release/src/CMakeLists.txt
--- 2.10.15-1/Release/src/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -236,9 +236,9 @@ else()
 endif()
 
 if(CPPREST_INSTALL_HEADERS)
-  install(FILES ${HEADERS_CPPREST} DESTINATION include/cpprest)
-  install(FILES ${HEADERS_PPLX} DESTINATION include/pplx)
-  install(FILES ${HEADERS_DETAILS} DESTINATION include/cpprest/details)
+  install(FILES ${HEADERS_CPPREST} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpprest)
+  install(FILES ${HEADERS_PPLX} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pplx)
+  install(FILES ${HEADERS_DETAILS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpprest/details)
 endif()
 
 if(CPPREST_INSTALL)
@@ -281,9 +281,10 @@ if(CPPREST_INSTALL)
   )
 
   configure_file(../cmake/cpprestsdk-config.in.cmake "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake" @ONLY)
+  configure_file(../cmake/cpprestsdk-config-version.in.cmake "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config-version.cmake" @ONLY)
 
   install(
-    FILES "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake"
+    FILES "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config-version.cmake"
     DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CPPREST_EXPORT_DIR}
   )
   install(
diff -pruN 2.10.15-1/Release/src/http/client/http_client_asio.cpp 2.10.16-1/Release/src/http/client/http_client_asio.cpp
--- 2.10.15-1/Release/src/http/client/http_client_asio.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/http/client/http_client_asio.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -333,7 +333,8 @@ public:
     void enable_no_delay()
     {
         boost::asio::ip::tcp::no_delay option(true);
-        m_socket.set_option(option);
+        boost::system::error_code error_ignored;
+        m_socket.set_option(option, error_ignored);
     }
 
 private:
@@ -1976,6 +1977,162 @@ void asio_client::send_request(const std
     ctx->start_request();
 }
 
+static bool is_retrieval_redirection(status_code code)
+{
+    // See https://tools.ietf.org/html/rfc7231#section-6.4
+
+    switch (code)
+    {
+    case status_codes::MovedPermanently:
+        // "For historical reasons, a user agent MAY change the request method
+        // from POST to GET for the subsequent request."
+        return true;
+    case status_codes::Found:
+        // "For historical reasons, a user agent MAY change the request method
+        // from POST to GET for the subsequent request."
+        return true;
+    case status_codes::SeeOther:
+        // "A user agent can perform a [GET or HEAD] request. It is primarily
+        // used to allow the output of a POST action to redirect the user agent
+        // to a selected resource."
+        return true;
+    default:
+        return false;
+    }
+}
+
+static bool is_unchanged_redirection(status_code code)
+{
+    // See https://tools.ietf.org/html/rfc7231#section-6.4
+    // and https://tools.ietf.org/html/rfc7538#section-3
+
+    switch (code)
+    {
+    case status_codes::TemporaryRedirect:
+        // "The user agent MUST NOT change the request method if it performs an
+        // automatic redirection to that URI."
+        return true;
+    case status_codes::PermanentRedirect:
+        // This status code "does not allow changing the request method from POST
+        // to GET."
+        return true;
+    default:
+        return false;
+    }
+}
+
+static bool is_recognized_redirection(status_code code)
+{
+    // other 3xx status codes, e.g. 300 Multiple Choices, are not handled
+    // and should be handled externally
+    return is_retrieval_redirection(code) || is_unchanged_redirection(code);
+}
+
+static bool is_retrieval_request(method method)
+{
+    return methods::GET == method || methods::HEAD == method;
+}
+
+static const std::vector<utility::string_t> request_body_header_names =
+{
+    header_names::content_encoding,
+    header_names::content_language,
+    header_names::content_length,
+    header_names::content_location,
+    header_names::content_type
+};
+
+// A request continuation that follows redirects according to the specified configuration.
+// This implementation only supports retrieval redirects, as it cannot redirect e.g. a POST request
+// using the same method since the request body may have been consumed.
+struct http_redirect_follower
+{
+    http_client_config config;
+    std::vector<uri> followed_urls;
+    http_request redirect;
+
+    http_redirect_follower(http_client_config config, const http_request& request);
+
+    uri url_to_follow(const http_response& response) const;
+
+    pplx::task<http_response> operator()(http_response response);
+};
+
+http_redirect_follower::http_redirect_follower(http_client_config config, const http_request& request)
+    : config(std::move(config))
+    , followed_urls(1, request.absolute_uri())
+    , redirect(request.method())
+{
+    // Stash the original request URL, etc. to be prepared for an automatic redirect
+
+    // Basically, it makes sense to send the redirects with the same headers as the original request
+    redirect.headers() = request.headers();
+    // However, this implementation only supports retrieval redirects, with no body, so Content-* headers
+    // should be removed
+    for (const auto& content_header : request_body_header_names)
+    {
+        redirect.headers().remove(content_header);
+    }
+
+    redirect._set_cancellation_token(request._cancellation_token());
+}
+
+uri http_redirect_follower::url_to_follow(const http_response& response) const
+{
+    // Return immediately if the response is not a supported redirection
+    if (!is_recognized_redirection(response.status_code()))
+        return{};
+
+    // Although not required by RFC 7231, config may limit the number of automatic redirects
+    // (followed_urls includes the initial request URL, hence '<' here)
+    if (config.max_redirects() < followed_urls.size())
+        return{};
+
+    // Can't very well automatically redirect if the server hasn't provided a Location
+    const auto location = response.headers().find(header_names::location);
+    if (response.headers().end() == location)
+        return{};
+
+    uri to_follow(followed_urls.back().resolve_uri(location->second));
+
+    // Config may prohibit automatic redirects from HTTPS to HTTP
+    if (!config.https_to_http_redirects() && followed_urls.back().scheme() == _XPLATSTR("https")
+        && to_follow.scheme() != _XPLATSTR("https"))
+        return{};
+
+    // "A client SHOULD detect and intervene in cyclical redirections."
+    if (followed_urls.end() != std::find(followed_urls.begin(), followed_urls.end(), to_follow))
+        return{};
+
+    return to_follow;
+}
+
+pplx::task<http_response> http_redirect_follower::operator()(http_response response)
+{
+    // Return immediately if the response doesn't indicate a valid automatic redirect
+    uri to_follow = url_to_follow(response);
+    if (to_follow.is_empty())
+        return pplx::task_from_result(response);
+
+    // This implementation only supports retrieval redirects, as it cannot redirect e.g. a POST request
+    // using the same method since the request body may have been consumed.
+    if (!is_retrieval_request(redirect.method()) && !is_retrieval_redirection(response.status_code()))
+        return pplx::task_from_result(response);
+
+    if (!is_retrieval_request(redirect.method()))
+        redirect.set_method(methods::GET);
+
+    // If the reply to this request is also a redirect, we want visibility of that
+    auto config_no_redirects = config;
+    config_no_redirects.set_max_redirects(0);
+    http_client client(to_follow, config_no_redirects);
+
+    // Stash the redirect request URL and make the request with the same continuation
+    auto request_task = client.request(redirect, redirect._cancellation_token());
+    followed_urls.push_back(std::move(to_follow));
+    return request_task.then(std::move(*this));
+}
+
 pplx::task<http_response> asio_client::propagate(http_request request)
 {
     auto self = std::static_pointer_cast<_http_client_communicator>(shared_from_this());
@@ -1995,7 +2152,9 @@ pplx::task<http_response> asio_client::p
     // Asynchronously send the response with the HTTP client implementation.
     this->async_send_request(context);
 
-    return result_task;
+    return client_config().max_redirects() > 0
+        ? result_task.then(http_redirect_follower(client_config(), request))
+        : result_task;
 }
 } // namespace details
 } // namespace client
diff -pruN 2.10.15-1/Release/src/http/client/http_client_winhttp.cpp 2.10.16-1/Release/src/http/client/http_client_winhttp.cpp
--- 2.10.15-1/Release/src/http/client/http_client_winhttp.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/http/client/http_client_winhttp.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -263,6 +263,8 @@ public:
     bool m_proxy_authentication_tried;
     bool m_server_authentication_tried;
 
+    size_t m_remaining_redirects;
+
     msg_body_type m_bodyType;
 
     utility::size64_t m_remaining_to_write;
@@ -679,6 +681,7 @@ private:
         , m_request_handle(nullptr)
         , m_proxy_authentication_tried(false)
         , m_server_authentication_tried(false)
+        , m_remaining_redirects(0)
         , m_bodyType(no_body)
         , m_remaining_to_write(0)
         , m_startingPosition(std::char_traits<uint8_t>::eof())
@@ -892,12 +895,14 @@ protected:
             return GetLastError();
         }
 
-        // Set timeouts.
-        int milliseconds = static_cast<int>(config.timeout<std::chrono::milliseconds>().count());
-        milliseconds = std::max<decltype(milliseconds)>(milliseconds, 1);
-        if (!WinHttpSetTimeouts(m_hSession, milliseconds, milliseconds, milliseconds, milliseconds))
         {
-            return GetLastError();
+            // Set timeouts.
+            const int milliseconds =
+                (std::max)(static_cast<int>(config.timeout<std::chrono::milliseconds>().count()), 1);
+            if (!WinHttpSetTimeouts(m_hSession, milliseconds, milliseconds, milliseconds, milliseconds))
+            {
+                return GetLastError();
+            }
         }
 
         if (config.guarantee_order())
@@ -911,19 +916,18 @@ protected:
             }
         }
 
-        // Enable TLS 1.1 and 1.2
-#if (_WIN32_WINNT >= _WIN32_WINNT_VISTA) || defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
-        BOOL win32_result(FALSE);
-
-        DWORD secure_protocols(WINHTTP_FLAG_SECURE_PROTOCOL_SSL3 | WINHTTP_FLAG_SECURE_PROTOCOL_TLS1 |
-                               WINHTTP_FLAG_SECURE_PROTOCOL_TLS1_1 | WINHTTP_FLAG_SECURE_PROTOCOL_TLS1_2);
-        win32_result = ::WinHttpSetOption(
-            m_hSession, WINHTTP_OPTION_SECURE_PROTOCOLS, &secure_protocols, sizeof(secure_protocols));
-        if (FALSE == win32_result)
         {
-            return GetLastError();
-        }
+            // Enable TLS 1.1 and 1.2
+#if (_WIN32_WINNT >= _WIN32_WINNT_VISTA) || defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
+            DWORD secure_protocols(WINHTTP_FLAG_SECURE_PROTOCOL_SSL3 | WINHTTP_FLAG_SECURE_PROTOCOL_TLS1 |
+                                   WINHTTP_FLAG_SECURE_PROTOCOL_TLS1_1 | WINHTTP_FLAG_SECURE_PROTOCOL_TLS1_2);
+            if (!WinHttpSetOption(
+                m_hSession, WINHTTP_OPTION_SECURE_PROTOCOLS, &secure_protocols, sizeof(secure_protocols)))
+            {
+                return GetLastError();
+            }
 #endif
+        }
 
         config._invoke_nativesessionhandle_options(m_hSession);
 
@@ -932,7 +936,8 @@ protected:
             WinHttpSetStatusCallback(m_hSession,
                                      &winhttp_client::completion_callback,
                                      WINHTTP_CALLBACK_FLAG_ALL_COMPLETIONS | WINHTTP_CALLBACK_FLAG_HANDLES |
-                                         WINHTTP_CALLBACK_FLAG_SECURE_FAILURE | WINHTTP_CALLBACK_FLAG_SEND_REQUEST,
+                                         WINHTTP_CALLBACK_FLAG_SECURE_FAILURE | WINHTTP_CALLBACK_FLAG_SEND_REQUEST |
+                                         WINHTTP_CALLBACK_STATUS_REDIRECT,
                                      0))
         {
             return GetLastError();
@@ -1128,6 +1133,63 @@ protected:
             return;
         }
 
+// WinHttpPAL does not currently provide these options
+// See https://github.com/microsoft/WinHttpPAL/issues/1
+#if !defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
+        if (client_config().max_redirects() == 0)
+        {
+            // Disable auto redirects.
+            DWORD redirectPolicy = WINHTTP_OPTION_REDIRECT_POLICY_NEVER;
+            if (!WinHttpSetOption(winhttp_context->m_request_handle,
+                                  WINHTTP_OPTION_REDIRECT_POLICY,
+                                  &redirectPolicy,
+                                  sizeof(redirectPolicy)))
+            {
+                auto errorCode = GetLastError();
+                request->report_error(errorCode, build_error_msg(errorCode, "Setting redirect policy"));
+                return;
+            }
+            // Note, using WINHTTP_OPTION_DISABLE_FEATURE with WINHTTP_DISABLE_REDIRECTS here doesn't seem to work.
+        }
+        else
+        {
+            // Set max auto redirects.
+
+            // Add 1 to config value because WinHttp option counts the original request.
+            // And another 1 to enable the response (headers) of the rejected automatic redirect to be returned
+            // rather than reporting an error "WinHttpReceiveResponse: 12156: The HTTP redirect request failed".
+            DWORD maxRedirects = client_config().max_redirects() < MAXDWORD - 2
+                ? static_cast<DWORD>(client_config().max_redirects() + 2)
+                : MAXDWORD;
+            // Therefore, effective max redirects
+            winhttp_context->m_remaining_redirects = maxRedirects - 2;
+
+            if (!WinHttpSetOption(winhttp_context->m_request_handle,
+                                  WINHTTP_OPTION_MAX_HTTP_AUTOMATIC_REDIRECTS,
+                                  &maxRedirects,
+                                  sizeof(maxRedirects)))
+            {
+                auto errorCode = GetLastError();
+                request->report_error(errorCode, build_error_msg(errorCode, "Setting max automatic redirects"));
+                return;
+            }
+
+            // (Dis)allow HTTPS to HTTP redirects.
+            DWORD redirectPolicy = client_config().https_to_http_redirects()
+                ? WINHTTP_OPTION_REDIRECT_POLICY_ALWAYS
+                : WINHTTP_OPTION_REDIRECT_POLICY_DISALLOW_HTTPS_TO_HTTP;
+            if (!WinHttpSetOption(winhttp_context->m_request_handle,
+                                  WINHTTP_OPTION_REDIRECT_POLICY,
+                                  &redirectPolicy,
+                                  sizeof(redirectPolicy)))
+            {
+                auto errorCode = GetLastError();
+                request->report_error(errorCode, build_error_msg(errorCode, "Setting redirect policy"));
+                return;
+            }
+        }
+#endif
+
         size_t content_length;
         try
         {
@@ -1974,11 +2036,17 @@ private:
                 }
                 return;
             }
-            case WINHTTP_CALLBACK_STATUS_SENDING_REQUEST: p_request_context->on_send_request_validate_cn(); return;
+            case WINHTTP_CALLBACK_STATUS_SENDING_REQUEST:
+            {
+                p_request_context->on_send_request_validate_cn();
+                return;
+            }
             case WINHTTP_CALLBACK_STATUS_SECURE_FAILURE:
+            {
                 p_request_context->report_exception(web::http::http_exception(
                     generate_security_failure_message(*reinterpret_cast<std::uint32_t*>(statusInfo))));
                 return;
+            }
             case WINHTTP_CALLBACK_STATUS_WRITE_COMPLETE:
             {
                 DWORD bytesWritten = *((DWORD*)statusInfo);
@@ -2026,6 +2094,49 @@ private:
                 }
                 return;
             }
+            case WINHTTP_CALLBACK_STATUS_REDIRECT:
+            {
+                // Return and continue unless that's too many automatic redirects.
+                if (p_request_context->m_remaining_redirects > 0)
+                {
+                    --p_request_context->m_remaining_redirects;
+                    return;
+                }
+
+                // First need to query to see what the headers size is.
+                DWORD headerBufferLength = 0;
+                query_header_length(hRequestHandle, WINHTTP_QUERY_RAW_HEADERS_CRLF, headerBufferLength);
+
+                // Now allocate buffer for headers and query for them.
+                std::vector<unsigned char> header_raw_buffer;
+                header_raw_buffer.resize(headerBufferLength);
+                utility::char_t* header_buffer = reinterpret_cast<utility::char_t*>(&header_raw_buffer[0]);
+                if (!WinHttpQueryHeaders(hRequestHandle,
+                                         WINHTTP_QUERY_RAW_HEADERS_CRLF,
+                                         WINHTTP_HEADER_NAME_BY_INDEX,
+                                         header_buffer,
+                                         &headerBufferLength,
+                                         WINHTTP_NO_HEADER_INDEX))
+                {
+                    auto errorCode = GetLastError();
+                    p_request_context->report_error(errorCode, build_error_msg(errorCode, "WinHttpQueryHeaders"));
+                    return;
+                }
+
+                http_response& response = p_request_context->m_response;
+                parse_winhttp_headers(hRequestHandle, header_buffer, response);
+
+                // Signal that the headers are available.
+                p_request_context->complete_headers();
+
+                // The body of the message is unavailable in WINHTTP_CALLBACK_STATUS_REDIRECT.
+                p_request_context->allocate_request_space(nullptr, 0);
+                p_request_context->complete_request(0);
+
+                // Cancel the WinHTTP operation by closing the handle.
+                p_request_context->cleanup();
+                return;
+            }
             case WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE:
             {
                 // First need to query to see what the headers size is.
@@ -2045,7 +2156,6 @@ private:
                 {
                     auto errorCode = GetLastError();
                     p_request_context->report_error(errorCode, build_error_msg(errorCode, "WinHttpQueryHeaders"));
-                    ;
                     return;
                 }
 
diff -pruN 2.10.15-1/Release/src/http/listener/http_server_api.cpp 2.10.16-1/Release/src/http/listener/http_server_api.cpp
--- 2.10.15-1/Release/src/http/listener/http_server_api.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/http/listener/http_server_api.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -50,7 +50,7 @@ void http_server_api::unregister_server_
         throw http_exception(_XPLATSTR("Server API was cleared while listeners were still attached"));
     }
 
-    s_server_api.release();
+    s_server_api.reset();
 }
 
 void http_server_api::unsafe_register_server_api(std::unique_ptr<http_server> server_api)
diff -pruN 2.10.15-1/Release/src/http/listener/http_server_asio.cpp 2.10.16-1/Release/src/http/listener/http_server_asio.cpp
--- 2.10.15-1/Release/src/http/listener/http_server_asio.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/http/listener/http_server_asio.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -594,7 +594,8 @@ void hostport_listener::on_accept(std::u
     if (!ec)
     {
         boost::asio::ip::tcp::no_delay option(true);
-        socket->set_option(option);
+        boost::system::error_code error_ignored;
+        socket->set_option(option, error_ignored);
 
         auto conn = asio_server_connection::create(std::move(socket), m_p_server, this);
 
diff -pruN 2.10.15-1/Release/src/http/listener/http_server_httpsys.cpp 2.10.16-1/Release/src/http/listener/http_server_httpsys.cpp
--- 2.10.15-1/Release/src/http/listener/http_server_httpsys.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/http/listener/http_server_httpsys.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -32,7 +32,7 @@ using namespace http::details;
 using namespace http::experimental::listener;
 using namespace http::experimental::details;
 
-#define CHUNK_SIZE 64 * 1024
+#define CHUNK_SIZE (64 * 1024)
 
 namespace web
 {
diff -pruN 2.10.15-1/Release/src/json/json_parsing.cpp 2.10.16-1/Release/src/json/json_parsing.cpp
--- 2.10.15-1/Release/src/json/json_parsing.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/json/json_parsing.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -1040,7 +1040,7 @@ std::unique_ptr<web::json::details::_Val
                 case JSON_Parser<CharType>::Token::TKN_CloseBracket:
                     GetNextToken(tkn);
                     if (tkn.m_error) return utility::details::make_unique<web::json::details::_Null>();
-                    return std::move(result);
+                    return std::unique_ptr<web::json::details::_Value>(result.release());
                 default:
                     SetErrorCode(tkn, json_error::malformed_array_literal);
                     return utility::details::make_unique<web::json::details::_Null>();
@@ -1058,6 +1058,7 @@ template<typename CharType>
 std::unique_ptr<web::json::details::_Value> JSON_Parser<CharType>::_ParseValue(
     typename JSON_Parser<CharType>::Token& tkn)
 {
+    typedef std::unique_ptr<web::json::details::_Value> Vptr;
     switch (tkn.kind)
     {
         case JSON_Parser<CharType>::Token::TKN_OpenBrace:
@@ -1070,15 +1071,15 @@ std::unique_ptr<web::json::details::_Val
         }
         case JSON_Parser<CharType>::Token::TKN_StringLiteral:
         {
-            auto value = utility::details::make_unique<web::json::details::_String>(std::move(tkn.string_val),
+            Vptr value = utility::details::make_unique<web::json::details::_String>(std::move(tkn.string_val),
                                                                                     tkn.has_unescape_symbol);
             GetNextToken(tkn);
             if (tkn.m_error) return utility::details::make_unique<web::json::details::_Null>();
-            return std::move(value);
+            return value;
         }
         case JSON_Parser<CharType>::Token::TKN_IntegerLiteral:
         {
-            std::unique_ptr<web::json::details::_Number> value;
+            Vptr value;
             if (tkn.signed_number)
                 value = utility::details::make_unique<web::json::details::_Number>(tkn.int64_val);
             else
@@ -1086,21 +1087,21 @@ std::unique_ptr<web::json::details::_Val
 
             GetNextToken(tkn);
             if (tkn.m_error) return utility::details::make_unique<web::json::details::_Null>();
-            return std::move(value);
+            return value;
         }
         case JSON_Parser<CharType>::Token::TKN_NumberLiteral:
         {
-            auto value = utility::details::make_unique<web::json::details::_Number>(tkn.double_val);
+            Vptr value = utility::details::make_unique<web::json::details::_Number>(tkn.double_val);
             GetNextToken(tkn);
             if (tkn.m_error) return utility::details::make_unique<web::json::details::_Null>();
-            return std::move(value);
+            return value;
         }
         case JSON_Parser<CharType>::Token::TKN_BooleanLiteral:
         {
-            auto value = utility::details::make_unique<web::json::details::_Boolean>(tkn.boolean_val);
+            Vptr value = utility::details::make_unique<web::json::details::_Boolean>(tkn.boolean_val);
             GetNextToken(tkn);
             if (tkn.m_error) return utility::details::make_unique<web::json::details::_Null>();
-            return std::move(value);
+            return value;
         }
         case JSON_Parser<CharType>::Token::TKN_NullLiteral:
         {
@@ -1120,10 +1121,11 @@ std::unique_ptr<web::json::details::_Val
 } // namespace json
 } // namespace web
 
-static web::json::value _parse_stream(utility::istream_t& stream)
+template<typename CharType>
+static web::json::value _parse_stream(std::basic_istream<CharType>& stream)
 {
-    web::json::details::JSON_StreamParser<utility::char_t> parser(stream);
-    web::json::details::JSON_Parser<utility::char_t>::Token tkn;
+    web::json::details::JSON_StreamParser<CharType> parser(stream);
+    typename web::json::details::JSON_Parser<CharType>::Token tkn;
 
     parser.GetNextToken(tkn);
     if (tkn.m_error)
@@ -1136,7 +1138,7 @@ static web::json::value _parse_stream(ut
     {
         web::json::details::CreateException(tkn, utility::conversions::to_string_t(tkn.m_error.message()));
     }
-    else if (tkn.kind != web::json::details::JSON_Parser<utility::char_t>::Token::TKN_EOF)
+    else if (tkn.kind != web::json::details::JSON_Parser<CharType>::Token::TKN_EOF)
     {
         web::json::details::CreateException(tkn,
                                             _XPLATSTR("Left-over characters in stream after parsing a JSON value"));
@@ -1144,10 +1146,11 @@ static web::json::value _parse_stream(ut
     return value;
 }
 
-static web::json::value _parse_stream(utility::istream_t& stream, std::error_code& error)
+template<typename CharType>
+static web::json::value _parse_stream(std::basic_istream<CharType>& stream, std::error_code& error)
 {
-    web::json::details::JSON_StreamParser<utility::char_t> parser(stream);
-    web::json::details::JSON_Parser<utility::char_t>::Token tkn;
+    web::json::details::JSON_StreamParser<CharType> parser(stream);
+    typename web::json::details::JSON_Parser<CharType>::Token tkn;
 
     parser.GetNextToken(tkn);
     if (tkn.m_error)
@@ -1157,7 +1160,7 @@ static web::json::value _parse_stream(ut
     }
 
     auto returnObject = parser.ParseValue(tkn);
-    if (tkn.kind != web::json::details::JSON_Parser<utility::char_t>::Token::TKN_EOF)
+    if (tkn.kind != web::json::details::JSON_Parser<CharType>::Token::TKN_EOF)
     {
         web::json::details::SetErrorCode(tkn, web::json::details::json_error::left_over_character_in_stream);
     }
@@ -1166,11 +1169,11 @@ static web::json::value _parse_stream(ut
     return returnObject;
 }
 
-#ifdef _WIN32
-static web::json::value _parse_narrow_stream(std::istream& stream)
+template<typename CharType>
+static web::json::value _parse_string(const std::basic_string<CharType>& str)
 {
-    web::json::details::JSON_StreamParser<char> parser(stream);
-    web::json::details::JSON_StreamParser<char>::Token tkn;
+    web::json::details::JSON_StringParser<CharType> parser(str);
+    typename web::json::details::JSON_Parser<CharType>::Token tkn;
 
     parser.GetNextToken(tkn);
     if (tkn.m_error)
@@ -1183,7 +1186,7 @@ static web::json::value _parse_narrow_st
     {
         web::json::details::CreateException(tkn, utility::conversions::to_string_t(tkn.m_error.message()));
     }
-    else if (tkn.kind != web::json::details::JSON_Parser<char>::Token::TKN_EOF)
+    else if (tkn.kind != web::json::details::JSON_Parser<CharType>::Token::TKN_EOF)
     {
         web::json::details::CreateException(tkn,
                                             _XPLATSTR("Left-over characters in stream after parsing a JSON value"));
@@ -1191,10 +1194,11 @@ static web::json::value _parse_narrow_st
     return value;
 }
 
-static web::json::value _parse_narrow_stream(std::istream& stream, std::error_code& error)
+template<typename CharType>
+static web::json::value _parse_string(const std::basic_string<CharType>& str, std::error_code& error)
 {
-    web::json::details::JSON_StreamParser<char> parser(stream);
-    web::json::details::JSON_StreamParser<char>::Token tkn;
+    web::json::details::JSON_StringParser<CharType> parser(str);
+    typename web::json::details::JSON_Parser<CharType>::Token tkn;
 
     parser.GetNextToken(tkn);
     if (tkn.m_error)
@@ -1204,7 +1208,7 @@ static web::json::value _parse_narrow_st
     }
 
     auto returnObject = parser.ParseValue(tkn);
-    if (tkn.kind != web::json::details::JSON_Parser<utility::char_t>::Token::TKN_EOF)
+    if (tkn.kind != web::json::details::JSON_Parser<CharType>::Token::TKN_EOF)
     {
         returnObject = web::json::value();
         web::json::details::SetErrorCode(tkn, web::json::details::json_error::left_over_character_in_stream);
@@ -1213,53 +1217,12 @@ static web::json::value _parse_narrow_st
     error = std::move(tkn.m_error);
     return returnObject;
 }
-#endif
 
-web::json::value web::json::value::parse(const utility::string_t& str)
-{
-    web::json::details::JSON_StringParser<utility::char_t> parser(str);
-    web::json::details::JSON_Parser<utility::char_t>::Token tkn;
-
-    parser.GetNextToken(tkn);
-    if (tkn.m_error)
-    {
-        web::json::details::CreateException(tkn, utility::conversions::to_string_t(tkn.m_error.message()));
-    }
-
-    auto value = parser.ParseValue(tkn);
-    if (tkn.m_error)
-    {
-        web::json::details::CreateException(tkn, utility::conversions::to_string_t(tkn.m_error.message()));
-    }
-    else if (tkn.kind != web::json::details::JSON_Parser<utility::char_t>::Token::TKN_EOF)
-    {
-        web::json::details::CreateException(tkn,
-                                            _XPLATSTR("Left-over characters in stream after parsing a JSON value"));
-    }
-    return value;
-}
+web::json::value web::json::value::parse(const utility::string_t& str) { return _parse_string(str); }
 
 web::json::value web::json::value::parse(const utility::string_t& str, std::error_code& error)
 {
-    web::json::details::JSON_StringParser<utility::char_t> parser(str);
-    web::json::details::JSON_Parser<utility::char_t>::Token tkn;
-
-    parser.GetNextToken(tkn);
-    if (tkn.m_error)
-    {
-        error = std::move(tkn.m_error);
-        return web::json::value();
-    }
-
-    auto returnObject = parser.ParseValue(tkn);
-    if (tkn.kind != web::json::details::JSON_Parser<utility::char_t>::Token::TKN_EOF)
-    {
-        returnObject = web::json::value();
-        web::json::details::SetErrorCode(tkn, web::json::details::json_error::left_over_character_in_stream);
-    }
-
-    error = std::move(tkn.m_error);
-    return returnObject;
+    return _parse_string(str, error);
 }
 
 web::json::value web::json::value::parse(utility::istream_t& stream) { return _parse_stream(stream); }
@@ -1270,10 +1233,17 @@ web::json::value web::json::value::parse
 }
 
 #ifdef _WIN32
-web::json::value web::json::value::parse(std::istream& stream) { return _parse_narrow_stream(stream); }
+web::json::value web::json::value::parse(const std::string& str) { return _parse_string(str); }
+
+web::json::value web::json::value::parse(const std::string& str, std::error_code& error)
+{
+    return _parse_string(str, error);
+}
+
+web::json::value web::json::value::parse(std::istream& stream) { return _parse_stream(stream); }
 
 web::json::value web::json::value::parse(std::istream& stream, std::error_code& error)
 {
-    return _parse_narrow_stream(stream, error);
+    return _parse_stream(stream, error);
 }
 #endif
diff -pruN 2.10.15-1/Release/src/pch/stdafx.h 2.10.16-1/Release/src/pch/stdafx.h
--- 2.10.15-1/Release/src/pch/stdafx.h	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/pch/stdafx.h	2020-04-25 00:44:16.000000000 +0000
@@ -40,7 +40,7 @@
 // Windows Header Files:
 #ifndef __cplusplus_winrt
 #include <winhttp.h>
-#endif !__cplusplus_winrt
+#endif // !__cplusplus_winrt
 
 #else // LINUX or APPLE
 #define __STDC_LIMIT_MACROS
diff -pruN 2.10.15-1/Release/src/streams/fileio_win32.cpp 2.10.16-1/Release/src/streams/fileio_win32.cpp
--- 2.10.15-1/Release/src/streams/fileio_win32.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/streams/fileio_win32.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -111,7 +111,7 @@ void CALLBACK IoCompletionCallback(PTP_C
 
     EXTENDED_OVERLAPPED* pExtOverlapped = static_cast<EXTENDED_OVERLAPPED*>(pOverlapped);
     pExtOverlapped->func(result, static_cast<DWORD>(numberOfBytesTransferred), static_cast<LPOVERLAPPED>(pOverlapped));
-    delete pOverlapped;
+    delete pExtOverlapped;
 }
 #endif
 
@@ -399,10 +399,10 @@ size_t _write_file_async(_In_ streams::d
 
     size_t result = static_cast<size_t>(-1);
 
-    if (wrResult == TRUE)
+    if (wrResult)
     {
         // If WriteFile returned true, it must be because the operation completed immediately.
-        // However, we didn't pass in an  address for the number of bytes written, so
+        // However, we didn't pass in an address for the number of bytes written, so
         // we have to retrieve it using 'GetOverlappedResult,' which may, in turn, fail.
         DWORD written = 0;
         result = GetOverlappedResult(fInfo->m_handle, pOverlapped.get(), &written, FALSE) ? static_cast<size_t>(written)
@@ -496,7 +496,7 @@ size_t _read_file_async(_In_ streams::de
 
     size_t result = static_cast<size_t>(-1);
 
-    if (wrResult == TRUE)
+    if (wrResult)
     {
         // If ReadFile returned true, it must be because the operation completed immediately.
         // However, we didn't pass in an address for the number of bytes written, so
@@ -941,7 +941,7 @@ utility::size64_t __cdecl _get_size(_In_
 
     LARGE_INTEGER size;
 
-    if (GetFileSizeEx(fInfo->m_handle, &size) == TRUE)
+    if (GetFileSizeEx(fInfo->m_handle, &size))
         return utility::size64_t(size.QuadPart / char_size);
     else
         return 0;
diff -pruN 2.10.15-1/Release/src/utilities/asyncrt_utils.cpp 2.10.16-1/Release/src/utilities/asyncrt_utils.cpp
--- 2.10.15-1/Release/src/utilities/asyncrt_utils.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/src/utilities/asyncrt_utils.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -1148,7 +1148,7 @@ datetime __cdecl datetime::from_string(c
             {
                 tzHours = 8;
             }
-            else if ((tzCh == _XPLATSTR('+') || tzCh == _XPLATSTR('-')) && ascii_isdigit2(str[1]) &&
+            else if ((str[0] == _XPLATSTR('+') || str[0] == _XPLATSTR('-')) && ascii_isdigit2(str[1]) &&
                      ascii_isdigit(str[2]) && ascii_isdigit5(str[3]) && ascii_isdigit(str[4]))
             {
                 tzCh = str[0];
diff -pruN 2.10.15-1/Release/tests/common/TestRunner/CMakeLists.txt 2.10.16-1/Release/tests/common/TestRunner/CMakeLists.txt
--- 2.10.15-1/Release/tests/common/TestRunner/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/common/TestRunner/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -8,6 +8,9 @@ endif()
 
 add_executable(test_runner test_runner.cpp test_module_loader.cpp)
 target_link_libraries(test_runner PRIVATE unittestpp ${CMAKE_DL_LIBS})
+if (WIN32)
+  target_sources(test_runner PRIVATE test_runner.manifest)
+endif()
 
 if(BUILD_SHARED_LIBS AND NOT TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
 elseif(APPLE)
diff -pruN 2.10.15-1/Release/tests/common/TestRunner/test_runner.manifest 2.10.16-1/Release/tests/common/TestRunner/test_runner.manifest
--- 2.10.15-1/Release/tests/common/TestRunner/test_runner.manifest	1970-01-01 00:00:00.000000000 +0000
+++ 2.10.16-1/Release/tests/common/TestRunner/test_runner.manifest	2020-04-25 00:44:16.000000000 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
+<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
+  <compatibility xmlns="urn:schemas-microsoft-com:compatibility.v1">
+      <application>
+        <!--This Id value indicates the application supports Windows Vista functionality -->
+          <supportedOS Id="{e2011457-1546-43c5-a5fe-008deee3d3f0}"/>
+        <!--This Id value indicates the application supports Windows 7 functionality-->
+          <supportedOS Id="{35138b9a-5d96-4fbd-8e2d-a2440225f93a}"/>
+        <!--This Id value indicates the application supports Windows 8 functionality-->
+          <supportedOS Id="{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}"/>
+        <!--This Id value indicates the application supports Windows 8.1 functionality-->
+          <supportedOS Id="{1f676c76-80e1-4239-95bb-83d0f6d0da78}"/>
+        <!--This Id value indicates the application supports Windows 10 functionality -->
+          <supportedOS Id="{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}"/>
+      </application>
+  </compatibility>
+</assembly>
diff -pruN 2.10.15-1/Release/tests/functional/http/client/client_construction.cpp 2.10.16-1/Release/tests/functional/http/client/client_construction.cpp
--- 2.10.15-1/Release/tests/functional/http/client/client_construction.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/http/client/client_construction.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -173,7 +173,7 @@ SUITE(client_construction)
         VERIFY_ARE_EQUAL(baseclient2.base_uri(), m_uri);
     }
 
-#if defined(CPPREST_FORCE_HTTP_LISTENER_ASIO)
+#if !defined(_WIN32) && !defined(__cplusplus_winrt) || defined(CPPREST_FORCE_HTTP_CLIENT_ASIO)
 
     // Verify that the callback of sslcontext is called for HTTPS
     TEST_FIXTURE(uri_address, ssl_context_callback_https)
diff -pruN 2.10.15-1/Release/tests/functional/http/client/CMakeLists.txt 2.10.16-1/Release/tests/functional/http/client/CMakeLists.txt
--- 2.10.15-1/Release/tests/functional/http/client/CMakeLists.txt	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/http/client/CMakeLists.txt	2020-04-25 00:44:16.000000000 +0000
@@ -16,6 +16,7 @@ set(SOURCES
   pipeline_stage_tests.cpp
   progress_handler_tests.cpp
   proxy_tests.cpp
+  redirect_tests.cpp
   request_helper_tests.cpp
   request_stream_tests.cpp
   request_uri_tests.cpp
diff -pruN 2.10.15-1/Release/tests/functional/http/client/outside_tests.cpp 2.10.16-1/Release/tests/functional/http/client/outside_tests.cpp
--- 2.10.15-1/Release/tests/functional/http/client/outside_tests.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/http/client/outside_tests.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -50,14 +50,12 @@ SUITE(outside_tests)
 
             // CNN's main page doesn't use chunked transfer encoding.
             http_response response = client.request(methods::GET).get();
-            auto code = response.status_code();
-            VERIFY_IS_TRUE(code == status_codes::OK || code == status_codes::MovedPermanently);
+            VERIFY_ARE_EQUAL(status_codes::OK, response.status_code());
             response.content_ready().wait();
 
             // CNN's other pages do use chunked transfer encoding.
             response = client.request(methods::GET, U("us")).get();
-            code = response.status_code();
-            VERIFY_IS_TRUE(code == status_codes::OK || code == status_codes::MovedPermanently);
+            VERIFY_ARE_EQUAL(status_codes::OK, response.status_code());
             response.content_ready().wait();
         });
     }
@@ -248,10 +246,7 @@ SUITE(outside_tests)
         http_request req(methods::GET);
         req.headers().add(U("Host"), U("en.wikipedia.org"));
         auto response = client.request(req).get();
-        // WinHTTP will transparently follow the HTTP 301 upgrade request redirect,
-        // ASIO does not and will return the 301 directly.
-        const auto statusCode = response.status_code();
-        CHECK(statusCode == status_codes::OK || statusCode == status_codes::MovedPermanently);
+        VERIFY_ARE_EQUAL(status_codes::OK, response.status_code());
     }
 #endif // !defined(__cplusplus_winrt) && !defined(CPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
 
diff -pruN 2.10.15-1/Release/tests/functional/http/client/redirect_tests.cpp 2.10.16-1/Release/tests/functional/http/client/redirect_tests.cpp
--- 2.10.15-1/Release/tests/functional/http/client/redirect_tests.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/http/client/redirect_tests.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -0,0 +1,342 @@
+/***
+ * Copyright (C) Microsoft. All rights reserved.
+ * Licensed under the MIT license. See LICENSE.txt file in the project root for full license information.
+ *
+ * =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
+ *
+ * Tests cases for multiple requests and responses from an http_client.
+ *
+ * =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
+ ****/
+
+#include "stdafx.h"
+#ifdef _WIN32
+#include <Windows.h>
+#include <VersionHelpers.h>
+#endif // _WIN32
+
+using namespace web::http;
+using namespace web::http::client;
+
+using namespace tests::functional::http::utilities;
+
+#if defined(_WIN32) && !defined(CPPREST_FORCE_HTTP_CLIENT_ASIO)
+#define USING_WINHTTP 1
+#else
+#define USING_WINHTTP 0
+#endif
+
+namespace tests
+{
+namespace functional
+{
+namespace http
+{
+namespace client
+{
+pplx::task<void> next_reply_assert(
+    test_http_server* p_server,
+    const method& method,
+    const utility::string_t& path,
+    status_code code = status_codes::OK,
+    const utility::string_t& location = U(""))
+{
+    return p_server->next_request().then([=](test_request* p_request) {
+        http_asserts::assert_test_request_equals(p_request, method, path);
+        size_t content_length;
+        VERIFY_ARE_EQUAL(methods::POST == method,
+            p_request->match_header(header_names::content_length, content_length));
+
+        std::map<utility::string_t, utility::string_t> headers;
+        if (!location.empty())
+        {
+            headers[header_names::location] = location;
+        }
+
+        // web::http::details::get_default_reason_phrase is internal :-/
+        p_request->reply(code, {}, headers);
+    });
+}
+
+pplx::task<void> next_reply_assert(
+    test_http_server* p_server,
+    const utility::string_t& path,
+    status_code code = status_codes::OK,
+    const utility::string_t& location = U(""))
+{
+    return next_reply_assert(p_server, methods::GET, path, code, location);
+}
+
+SUITE(redirect_tests)
+{
+    TEST_FIXTURE(uri_address, follows_multiple_redirects_by_default)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::MovedPermanently, U("/moved-here")));
+        replies.push_back(next_reply_assert(p_server, U("/moved-here"), status_codes::TemporaryRedirect, U("/moved-there")));
+        replies.push_back(next_reply_assert(p_server, U("/moved-there"), status_codes::Found, U("/found-elsewhere")));
+        replies.push_back(next_reply_assert(p_server, U("/found-elsewhere")));
+
+        http_client_config config;
+        http_client client(m_uri, config);
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::OK)
+        );
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, follows_retrieval_redirect)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, methods::POST, U("/"), status_codes::SeeOther, U("/see-here")));
+        replies.push_back(next_reply_assert(p_server, methods::GET, U("/see-here")));
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::POST, U(""), U("body")).get(), status_codes::OK);
+        );
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, obeys_max_redirects)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::MovedPermanently, U("/moved-here")));
+        replies.push_back(next_reply_assert(p_server, U("/moved-here"), status_codes::TemporaryRedirect, U("/moved-there")));
+        replies.push_back(next_reply_assert(p_server, U("/moved-there"), status_codes::Found, U("/found-elsewhere")));
+
+        http_client_config config;
+        config.set_max_redirects(2);
+        http_client client(m_uri, config);
+
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::Found)
+        );
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, can_disable_redirects)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::MovedPermanently, U("/moved-here")));
+
+        http_client_config config;
+        config.set_max_redirects(0);
+        http_client client(m_uri, config);
+
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::MovedPermanently)
+        );
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST(does_not_follow_https_to_http_by_default)
+    {
+        handle_timeout([] {
+            http_client_config config;
+            http_client client(U("https://http.badssl.com/"), config);
+            VERIFY_NO_THROWS(
+                http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::MovedPermanently)
+            );
+        });
+    }
+
+    TEST(can_follow_https_to_http)
+    {
+        handle_timeout([] {
+            http_client_config config;
+            config.set_https_to_http_redirects(true);
+            http_client client(U("https://http.badssl.com/"), config);
+            VERIFY_NO_THROWS(
+                http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::OK)
+            );
+        });
+    }
+
+    TEST_FIXTURE(uri_address, follows_permanent_redirect)
+    {
+#if USING_WINHTTP
+        // note that 308 Permanent Redirect is only supported by WinHTTP from Windows 10
+        if (!IsWindows10OrGreater()) {
+            return;
+        }
+#endif // USING_WINHTTP
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::PermanentRedirect, U("/moved-here")));
+        replies.push_back(next_reply_assert(p_server, U("/moved-here")));
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::OK)
+        );
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, may_throw_if_no_location)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::MovedPermanently));
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        // implementation-specific behaviour
+#if USING_WINHTTP
+        VERIFY_THROWS(
+            client.request(methods::GET).get(),
+            http_exception
+        );
+#else
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::MovedPermanently)
+        );
+#endif
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, should_not_follow_cyclic_redirect)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::TemporaryRedirect, U("/briefly-here")));
+        replies.push_back(next_reply_assert(p_server, U("/briefly-here"), status_codes::MovedPermanently, U("/")));
+#if USING_WINHTTP
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::NotFound));
+#endif
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        // implementation-specific behaviour
+#if USING_WINHTTP
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::NotFound)
+        );
+#else // ^^^ USING_WINHTTP / !USING_WINHTTP vvv
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::MovedPermanently)
+        );
+#endif // USING_WINHTTP
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, may_follow_unchanged_redirect)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, methods::POST, U("/"), status_codes::TemporaryRedirect, U("/retry-here")));
+#if USING_WINHTTP
+        replies.push_back(next_reply_assert(p_server, methods::POST, U("/retry-here")));
+#endif
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        // implementation-specific behaviour
+#if USING_WINHTTP
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::POST, U(""), U("body")).get(), status_codes::OK)
+        );
+#else // ^^^ USING_WINHTTP / !USING_WINHTTP vvv
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::POST, U(""), U("body")).get(), status_codes::TemporaryRedirect)
+        );
+#endif // USING_WINHTTP
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+    TEST_FIXTURE(uri_address, may_not_follow_manual_redirect)
+    {
+        test_http_server::scoped_server scoped(m_uri);
+        auto p_server = scoped.server();
+
+        std::vector<pplx::task<void>> replies;
+        replies.push_back(next_reply_assert(p_server, U("/"), status_codes::MultipleChoices, U("/prefer-here")));
+#if USING_WINHTTP
+        replies.push_back(next_reply_assert(p_server, U("/prefer-here")));
+#endif
+
+        http_client_config config;
+        http_client client(m_uri, config);
+
+        // implementation-specific behaviour
+#if USING_WINHTTP
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::OK)
+        );
+#else // ^^^ USING_WINHTTP / !USING_WINHTTP vvv
+        VERIFY_NO_THROWS(
+            http_asserts::assert_response_equals(client.request(methods::GET).get(), status_codes::MultipleChoices)
+        );
+#endif // USING_WINHTTP
+        p_server->close();
+        for (auto& reply : replies)
+        {
+            VERIFY_NO_THROWS(reply.get());
+        }
+    }
+
+} // SUITE(redirect_tests)
+
+} // namespace client
+} // namespace http
+} // namespace functional
+} // namespace tests
diff -pruN 2.10.15-1/Release/tests/functional/http/listener/listener_construction_tests.cpp 2.10.16-1/Release/tests/functional/http/listener/listener_construction_tests.cpp
--- 2.10.15-1/Release/tests/functional/http/listener/listener_construction_tests.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/http/listener/listener_construction_tests.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -549,9 +549,13 @@ XzJTD4slrGSJrcpLt/g/Jqqdjg==
         listener.open().wait();
 
         client::http_client_config client_config;
+#if !defined(_WIN32) && !defined(__cplusplus_winrt) || defined(CPPREST_FORCE_HTTP_CLIENT_ASIO)
         client_config.set_ssl_context_callback(
             [&](boost::asio::ssl::context& ctx) { ctx.add_certificate_authority(cert); });
-
+#else
+        // in this build configuration, with WinHTTP-based http_client, this test will fail unless the self-signed
+        // cert is added to the Windows certificate store (or certificate validation is disabled in client_config)
+#endif
         client::http_client client(m_secure_uri, client_config);
         http_request msg(methods::GET);
         msg.set_request_uri(U("/"));
diff -pruN 2.10.15-1/Release/tests/functional/json/parsing_tests.cpp 2.10.16-1/Release/tests/functional/json/parsing_tests.cpp
--- 2.10.15-1/Release/tests/functional/json/parsing_tests.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/json/parsing_tests.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -347,7 +347,7 @@ SUITE(parsing_tests)
         VERIFY_ARE_EQUAL(U("K"), str.as_string());
 
         str = json::value::parse(U("\"\\u20AC\""));
-        // Euro sign as a hexidecmial UTF-8
+        // Euro sign as a hexadecimal UTF-8
         const auto euro = to_string_t("\xE2\x82\xAC");
         VERIFY_ARE_EQUAL(euro, str.as_string());
 
@@ -631,30 +631,34 @@ SUITE(parsing_tests)
     TEST(byte_ptr_parsing_array)
     {
         char s[] = "[ \"test1\",true]";
+        json::value v = json::value::parse(s);
         std::stringstream ss;
         ss << s;
-        json::value v = json::value::parse(ss);
-        auto s2 = v.serialize();
+        json::value vv = json::value::parse(ss);
+        VERIFY_ARE_EQUAL(v, vv);
 
+        auto s2 = v.serialize();
         VERIFY_ARE_EQUAL(s2, U("[\"test1\",true]"));
 
         std::stringstream os;
-        v.serialize(os);
+        vv.serialize(os);
         VERIFY_ARE_EQUAL(s2, to_string_t(os.str()));
     }
 
     TEST(byte_ptr_parsing_object)
     {
         char s[] = "{\"test1\":true }";
+        json::value v = json::value::parse(s);
         std::stringstream ss;
         ss << s;
-        json::value v = json::value::parse(ss);
-        auto s2 = v.serialize();
+        json::value vv = json::value::parse(ss);
+        VERIFY_ARE_EQUAL(v, vv);
 
+        auto s2 = v.serialize();
         VERIFY_ARE_EQUAL(s2, U("{\"test1\":true}"));
 
         std::stringstream os;
-        v.serialize(os);
+        vv.serialize(os);
         VERIFY_ARE_EQUAL(s2, to_string_t(os.str()));
     }
 
@@ -662,16 +666,18 @@ SUITE(parsing_tests)
     {
         utility::string_t ws = U("\"こんにちは\"");
         std::string s = to_utf8string(ws);
+        json::value v = json::value::parse(s);
 
         std::stringstream ss;
         ss << s;
-        json::value v = json::value::parse(ss);
-        auto s2 = v.serialize();
+        json::value vv = json::value::parse(ss);
+        VERIFY_ARE_EQUAL(v, vv);
 
+        auto s2 = v.serialize();
         VERIFY_ARE_EQUAL(s2, ws);
 
         std::stringstream os;
-        v.serialize(os);
+        vv.serialize(os);
         VERIFY_ARE_EQUAL(s2, to_string_t(os.str()));
     }
 
diff -pruN 2.10.15-1/Release/tests/functional/utils/datetime.cpp 2.10.16-1/Release/tests/functional/utils/datetime.cpp
--- 2.10.15-1/Release/tests/functional/utils/datetime.cpp	2020-02-24 04:33:51.000000000 +0000
+++ 2.10.16-1/Release/tests/functional/utils/datetime.cpp	2020-04-25 00:44:16.000000000 +0000
@@ -304,7 +304,8 @@ SUITE(datetime)
             _XPLATSTR("01 Jan 1971 00:00:61 GMT"),
             _XPLATSTR("01 Jan 1899 00:00:00 GMT"), // underflow
             _XPLATSTR("01 Jan 1969 00:00:00 CEST"), // bad tz
-            _XPLATSTR("01 Jan 1970 00:00:00 +2400"), // bad tzoffsets
+            _XPLATSTR("14 Jan 2019 23:16:21 G0100"), // bad tzoffsets
+            _XPLATSTR("01 Jan 1970 00:00:00 +2400"),
             _XPLATSTR("01 Jan 1970 00:00:00 -3000"),
             _XPLATSTR("01 Jan 1970 00:00:00 +2160"),
             _XPLATSTR("01 Jan 1970 00:00:00 -2400"),
